unit GcMM;
// Activate Garbage collector as default memeory manager for Delphi
//
// Version 1.0b
// Copyright 1997 Vladimir A. Merzlaikov (wanderer@npt.rnd.runnet.ru)
//
// Must be first unit in project
// ( before units with memory allocating in initialization code )
// Memeory blocks allocated std.methods - uncollectable
// Use GC.pas functions
interface

implementation

uses GC;

function GCGetMem( aSize : Integer ) : Pointer; far;
begin
  Result:=GC_malloc_uncollectable(Cardinal(aSize));
end;

function GCFreeMem( aPtr : Pointer ): Integer; far;
begin
  GC_free(aPtr);
  Result:=0;
end;

function GCReallocMem( aPtr : Pointer; aSize : Integer ): Pointer; far;
begin
  Result:=GC_realloc(aPtr,Cardinal(aSize));
end;

const
  gGCMM : TMemoryManager = (
    GetMem     : GCGetMem;
    FreeMem    : GCFreeMem;
    ReallocMem : GCReallocMem
  );

var aOldMM : TMemoryManager;
initialization
  GetMemoryManager(aOldMM);
  SetMemoryManager(gGCMM);
finalization
  SetMemoryManager(aOldMM);
end.
